#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum TagFilterOperator {
    #[serde(rename = "IN")]
    In,
    #[serde(rename = "NOT_IN")]
    NotIn,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl TagFilterOperator {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            TagFilterOperator::In => "IN",
            TagFilterOperator::NotIn => "NOT_IN",
            TagFilterOperator::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for TagFilterOperator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for TagFilterOperator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for TagFilterOperator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<TagFilterOperator, conjure_object::plain::ParseEnumError> {
        match v {
            "IN" => Ok(TagFilterOperator::In),
            "NOT_IN" => Ok(TagFilterOperator::NotIn),
            v => v.parse().map(|v| TagFilterOperator::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for TagFilterOperator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<TagFilterOperator, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the TagFilterOperator enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
